export default odaService({
    async execute(params) {
        let newObj;
        const srcObj = await this.$owner.$base.findItem(params.srcObj);

        const disableXQ = this.$owner.root.Disable;
        if (disableXQ) { 
            const xqRes = await srcObj.XQuery(`OBJECT/(${disableXQ})`);
            if (xqRes?.[0] === 'true') {
                ODA.push('Внимание!', {
                    //tag: 'fill',
                    body: `Условие шаблона '${this.$owner.name}' невыполнено! Объект не создан!`,
                    icon: 'icons:warning'
                });
                return null;
            }
        }

        let dstCls = await this.$owner.$base.findItem(this.$owner.Root.$Bind[0].DstClass);
        if (dstCls.hasChildren) {
            // TODO: show dialog
            const result = await ODA.showDialog('../../../../../web/lib/dialogs/select-class/select-class.js',
                { contextItem: dstCls, allowFilter: false, showWalker: false, itemKey: '$class' },
                { title: 'Select Class', icon: 'odant:class' });

            if (!result?.item) return newObj;
            
            dstCls = result.item;
        }

        // TODO: run server method
        const bindResult = await ODANT.API.post(this.$owner.url,
            { execute: 'methods/auto-fill', restart: 'true', srcObj: srcObj.fullId, dstCls: dstCls.fullId});

        // const hideSrc = this.$owner.Root.HiddenSource
        // if (hideSrc && (hideSrc.toLowerCase() === "true")) {
        // }
        
        const hideBind = this.$owner.root.HiddenBind;
        if (hideBind?.toLowerCase?.() !== "true") {
            if (Array.isArray(bindResult)) {
                const promises = bindResult.map((url) => srcObj.$class.findItem(url));
                return Promise.all(promises).then((bindObjs) => bindObjs.map((obj) => obj.show()));
            }

            newObj = srcObj.$class.findItem(bindResult).then(bindObj => bindObj.show());
        }

        const delSrc = this.$owner.root.DeleteSource;
        if (bindResult && (delSrc?.toLowerCase?.() === "true")) {
            srcObj.remove();
        }

        return newObj;
    }
})