(class extends odaAction {
    async execute(params) {
        let newObj;
        const srcObj = await this.$owner.$base.findItem(params.srcObj);

        const disableXQ = this.$owner.Root.Disable;
        if (disableXQ) { 
            const xqRes = await srcObj.XQuery(`OBJECT/(${disableXQ})`);
            if (xqRes && (xqRes.length > 0) && (xqRes[0] === 'true')) {
                ODA.push('Внимание!', {
                    //tag: 'fill',
                    body: `Условие шаблона '${this.$owner.name}' невыполнено! Объект не создан!`,
                    icon: 'icons:warning'
                });
                return null;
            }
        }

        let dstCls = await this.$owner.$base.findItem(this.$owner.Root.$Bind[0].DstClass);
        if (dstCls.hasChildren) {
            const component = await ODA.createComponent('/web/lib/dialogs/select-class/select-class.html',
                { contextItem: dstCls, allowFilter: false, showWalker: false, itemKey: '$class' });
            const result = await ODA.showDialog(component, { title: 'Select Class', icon: 'odant:class' });

            if (result && result.item) dstCls = result.item;
            else return newObj;
        }

        const bindResult = await ODANT.API.post(this.$owner.url,
            { execute: 'methods/auto-fill', restart: 'true', srcObj: srcObj.fullId, dstCls: dstCls.fullId});

        // const hideSrc = this.$owner.Root.HiddenSource
        // if (hideSrc && (hideSrc.toLowerCase() === "true")) {
        // }
        
        const hideBind = this.$owner.Root.HiddenBind;
        if (!hideBind || (hideBind.toLowerCase() !== "true")) {
            if (Array.isArray(bindResult)) {
                const promises = bindResult.map((url) => srcObj.$class.findItem(url));
                return Promise.all(promises).then((bindObjs) => bindObjs.map((obj) => obj.show()));
            }

            newObj = srcObj.$class.findItem(bindResult).then(bindObj => bindObj.show());
        }

        const delSrc = this.$owner.Root.DeleteSource;
        if (bindResult && delSrc && delSrc.toLowerCase() === "true") {
            srcObj.remove();
        }

        return newObj;
    }
}).register();