export default odaField ({
    is:'odaBoolField',
    _input: 'boolean',
    _labelTop: true,
    getValue(object, root){
        let val = this.$super.getValue.call(this, object, root);
        if (val && val.then)
            return val.then(val=> (val && val.toLowerCase() === 'true'));
        return (val && val.toLowerCase() === 'true')
    },
    setValue(object, value, root){
        return this.$super.setValue.call(this, object, value?'True':'False', root).then(value => {
            return (value && value.toLowerCase()) === 'true';
        })
    }
})
FIELD({
    is: "boolean",
    imports: '@oda/checkbox',
    extends: 'oda-checkbox',
    properties: {
        size: {
            get() {
                return this.iconSize;
            }
        },
        _isField: false,
    },
    observers: [
        function _setIsField (dataRoot, $field) { this._isField = true; this.state = 'unchecked'; },
        function _setState (dataRoot, $field, value) { if (dataRoot && $field) { this.state = value ? 'checked' : 'unchecked'; } },
        function _setValue (state) { if (this._isField) this.value = (state === 'checked' ? true : false); },
    ],
})