import * as LAYERS from "./layers.js";
export default CLASS({is: 'NeuralNetwork',
    props:{
        inputs(){
            return (this.layers?.[0]?.neurons || []);
        },
        layers:{
            default: [],
            set(d){
                this.__cache__.layers = [];
                for (let i of d) {
                    this.addLayer(i);
                }
            }
        }
    },
    addLayer(props = {}){
        props.net = this;
        props.index = this.layers.length;
        const layer =  new LAYERS[props.class](props);
        this.layers.push(layer);
        return layer;
    },
    removeLayer(layer){
        this.layers.remove(layer);
    },
    clone(){
        const clone = new NeuralNetwork(this.TheTopology, true);
        for (let i = 0; i < this.layers.length; i++) {
            clone.layers[i] = this.layers[i].clone();
        }
        return clone;
    },
    FeedForward(Input)
    {
        // Validation Checks
        if (Input === null)
            throw Error("The input array cannot be set to null.", "Input");
        else if (Input.length !== this.TheTopology[0])
            throw Error("The input array's length does not match the number of neurons in the input layer.", "Input");

        let Output = Input;

        for (let i = 0; i < this.layers.length; i++) {
            Output = this.layers[i].FeedForward(Output);
        }
        return Output;
    },
    mutate (probability = 0.5, amount = 2) {
        for (let i = 0; i < this.layers.length; i++)
            this.layers[i].mutate(probability, amount);
    },
    // fire(e, s) {
    //     const ev = new CustomEvent(e, { detail: { value: s }, composed: true })
    //     this._events[e].forEach(i => {
    //         i(ev);
    //     })
    // },
    // listen(e, h) {
    //     let a = this._events[e];
    //     if (!a) a = this._events[e] = [];
    //     a.push(h);
    // },
    getData(){
        const data = {name: this.name};
        data.layers = this.layers.map(i=>i.getData());
        return data;
    }
})
