/*
 * neuronet.js v1.0
 * (c) 2021 R.A. Perepelkin
 * Under the MIT License.
 */
function random(min = 1, max = 100) {
    return Math.floor(min + Math.random() * (max + 1 - min)) / 100;
}
class Neuron {
    __cache__ = {}
    _connects = []
    constructor(data, net) {
        this._net = net; // Указатель нейросети
        this._data = data; // Данные нейрона
        this.x = data.x; // X-Координата нейрона в сети
        this.y = data.y; // Y-Координата нейрона в сети
        this.z = data.z || 0; // Z-Координата нейрона в сети
        // this.s = data.s || []; // Вектора
        // this.s.forEach(s => s.w = random());
    }
    toString() {
        return `Neuron(${this.x},${this.y})`
    }

    $(key, callback) {
        let result = this.__cache__[key];
        if (result === undefined)
            result = this.__cache__[key] = callback();
        return result;
    }
    reset(...args) {
        args.forEach(i => {
            this.__cache__[i] = undefined;
        })
    }
}

export default class NeuroNet {
    delay = 100
    tree = {}
    x = 0
    y = 0
    z = 0
    neurons = []
    constructor(data) {
        this._data = data;
        this.bases = data.map(i => this.forceNeuron(i))
        this.run();
    }
    run() {

    }
    forceNeuron(data) {
        let x = this.tree[data.x];
        if (!x)
            x = this.tree[data.x] = {};
        let y = x[data.y];
        if (!y) {
            y = x[data.y] = new Neuron(data, this);
            this.neurons.push(y);
        }
        return y;
    }
}