export default odaPage({
    props: {
        label: 'App studio',
        category: 'developer',
        icon: 'icons:build',
        allowAccess: 'A',
        allowUse: function () {
            let contextFolder = this.$owner instanceof odaFolder ? this.$owner : this.$owner.$folder;
            if (!contextFolder || !(contextFolder instanceof odaFolder)) {
                return false;
            }
            return true;
        },
    }
});

ODANT({
    is: "app-studio",
    imports: [
        '@lib/item-tree',
        '@lib/item-node',
        '@oda/button',
        '@oda/app-layout',
        '@oda/basic',
        '@tools/icons-tree',
        '@oda/tabs',
        '@pages/form',
    ],
    extends: 'oda-app-layout',
    template: /*html*/`
    <!--<odant-action-bar slot="leftbar" :icon-size groups="developer" :context-item="contextItem" vertical class="vertical"></odant-action-bar>-->
    <!--<div slot="leftbar">
        <oda-button icon="icons:add" @tap="contextItem?.executeAction('add-item');"></oda-button>
    </div>-->
    <div icon="icons:tree-structure" slot="left-drawer" bar-autofocus>
        <odant-item-node :context-item class="no-flex header" style="margin: 0; padding: 4px;"></odant-item-node>
        <odant-item-tree allow-focus no-sort items-list="$$actionFolders, $$files" expand :context-item="contextItem?.$folder" ::focused-item hide-root :expand-keys-map="{label: ['client', 'server']}"></odant-item-tree>
    </div>
    <oda-tabs slot="top-left" template="odant-item-node" ref="tabs" :items="pages" class="horizontal flex" ::focused-index="pageIndex" @focused-index-changed="_setIndex" design-mode="false"></oda-tabs>
    <div ~if="contextItem" slot="main" class="vertical flex" :style="{height: '100%',background: \`url(\${contextItem.url + '/~/background.jpg'})\`}">
        <odant-form ~if="focusedItem && !(focusedItem instanceof odaFolder)" :context-item="focusedItem" hide-toolbar allow-save></odant-form>
    </div>
    <div slot="right-drawer" icon="icons:grade" bar-autofocus style="display: flex; flex-direction: column; overflow: hidden;">
        <div style="box-shadow: inset 0 0 0 1px gray; display: flex; align-items: center;">
            <oda-basic-input ::value="filterVal"></oda-basic-input>
            <oda-icon icon="icons:search" icon-size="32"></oda-icon>
        </div>
        <oda-icons-tree :filter-val :toot-path="/web/"></oda-icons-tree>
    </div> 
    <div slot="right-drawer" icon="icons:extension">Components</div>
    <div slot="right-drawer" icon="icons:menu">Types</div>
    `,
    // <odant-item-tree slot="left" :data-set :items-list :columns :groups></odant-item-tree>
    // <oda-tabs slot="title" template="odant-item-node" ref="tabs" :items="pages" class="horizontal flex" :focused-index="index" @focused-index-changed="focusedItem = pages[index]" design-mode="false"></oda-tabs>
    // <div class="vertical flex" :style="{background: \`url(\${contextItem && contextItem.url + '/~/background.jpg'})\`}">
    //     <odant-form :context-item="focusedItem"></odant-form>
    // </div>
    // <div slot="right" class="vertical flex" style="overflow: hidden;">
    //     <oda-app-studio-toolbox ref="toolbox" :context-item.prop="contextItem || focusedItem"></oda-app-studio-toolbox>
    // </div>
    // `,
    props: {
        iconSize: {
            default: 24,
            shared: true
        },
        showTitle: true,
        modal: false,
        leftbar: {
            type: Object,
            default: {
                visible: false,
                width: 32
            }
        },
        pages: {
            default: [],
            set(n) {
                if (!n?.length) {
                    this.focusedItem = null;
                }
            }
            // get(){
            //     return JSON.parse(sessionStorage.getItem(`app-studio/${this.contextItem?.path}/pages`) || '[]');
            // },
            // watch(n) {
            //     if(this.contextItem && n) {
            //         sessionStorage.setItem(`app-studio/${this.contextItem.path}/pages`, JSON.stringify(n));
            //     }
            // }
        },
        contextItem: Object,
        focusedItem: {
            type: Object,
            watch(n) {
                if (n) {
                    if (n instanceof odaFolder) return;
                    this.pageIndex = this.pages.findIndex(i => i.$item.path === n.path);
                    if (this.pageIndex < 0) {
                        this.pages.forEach(p => p.focused = false);
                        this.pages.push({ $item: n, designMode: true, focused: true }); //особенности реализации oda-tabs
                        this.pageIndex = this.pages.length - 1;
                    }

                }
                else {
                    this.pageIndex = -1;
                }
            }
        },
        pageIndex: {
            default: -1,
            set(n) {
                if (n === -1) this.focusedItem = null;
            }
        },
        filterVal: '',
        hideToolbar: false
    },
    _setIndex(e) {
        const n = e.detail.value;
        if (n === -1) this.focusedItem = null;
        else this.focusedItem = this.pages[n].$item;
    }
});