ODANT({
    imports: [
        '@lib/file-tree',
        '@oda/tile'
    ],
    is: 'odant-file-tile', extends: 'oda-tile, odant-file-tree',
    props: {
        focusedItem: Object,
        currentNode: Object,
        defaultTemplate: 'odant-item-node',
        showFiles: true,
        hideRoot: true,
        allowFocus: false,
    },
    observers: [
        function _setTemplates(viewModes) {
            if (viewModes) {
                viewModes.find(mode => mode.name === 'table').template = 'odant-file-tile-table-item';
                viewModes.find(mode => mode.name === 'icons').template = 'odant-file-tile-icon-item';
            }
        },
        function _setContexItem(currentNode) { // allowInherit, _extFilter - учесть в будущем, если нужно
            const item = currentNode && currentNode.$item
            if (item && item.addEventListener) {
                this.listen('event', '_onEvent', {target: item});
            }
            this.contextItem = item || null;
        }
    ],
    async updateCurrentNode(node) {
        if (!node) return;
        if (node.$item instanceof odaFolder) {
            const items = await this._beforeExpand(node);
            if (items) {
                // this.dataSet = items;
                this.setCurrentNode(node);
            }
        } else if (node.$item instanceof odaFile) {
            const result = await ODANT.show(node.$item);
        }
    }
});

import '/web/oda/components/grids/tile/tile.js'
ODA({
    is: 'odant-file-tile-table-item', extends: 'oda-tile-table-item',
    props: {
        _template: 'odant-item-node',
        _item: {
            get() {
                if (!this.item || !this.item.$item) return null;
                return Object.assign({}, {$item: this.item.$item, type: this.item.$item.type, size: this.item.$item.sizeText, time: this.transformTime(this.item.$item.time)});
            }
        }
    },
    transformTime(t, zone = 'ru') {
        if (t) return (new Date(t)).toLocaleString(zone);
        return ''
    }
});

ODA({
    is: 'odant-file-tile-icon-item', extends: 'odant-item-node',
    props: {
        hidePrefix: true
    }
})