export default odaView({
    label: 'Редактор',
    icon: 'icons:create',
})
class Cache {
    __c__ = {}
    cache(key, callback) {
        if (this.__c__[key] === undefined)
            this.__c__[key] = typeof callback === 'function' ? callback() : callback;
        return this.__c__[key];
    }
}
class LayoutItem extends Cache {
    constructor(item, listKey = '$$fields', parent) {
        super();
        this.$listKey = listKey;
        this.$item = item;
        this.$parent = parent;
    }
    get items() {
        return this.cache('items', async () => {
            const items = await this.$item[this.$listKey];
            return items.map(i => {
                return new LayoutItem(i, this.$listKey, this);
            })
        })
    }
    get input() {
        return this.cache('input', async () => {
            return await this.$item.input;
        })
    }
    get complex() {
        return this.cache('complex', async () => {
            return await this.$item.complex;
        })
    }
    set focused(v) {
        this._focused = v;
        if (v) {
            this.$parent.items.forEach && this.$parent.items.forEach(i => {
                if (i !== this)
                    i.focused = false;
            })
        }
        else {
            console.log('focused')
        }
    }
    get focused() {
        return this._focused;
    }
}

ODANT({
    imports: '@oda/icon',
    is: 'editor',
    extends: 'odant-layout-container',
    template: /*html*/`
        <style>
            :host{
                 @apply --flex;
                 overflow: auto;
            }
        </style>
    `,
    props: {
        contextItem: {
            async set(n) {
                this.root = new LayoutItem(n);
            }
        },
        root: Object,
        iconSize: 24,
        expanded: true,
        allowExpand: false,
    }
})
ODA({
    is: 'odant-layout-container',
    template: /*html*/`
        <style>
            :host{
                @apply --no-flex;
                @apply --vertical;
            }
            .complex{
                border-left: 1px dotted silver;
            }
            label{
                width: 100px;
                font-size: small;
                align-self: center;
                @apply --disabled;
            }
            oda-icon{
                cursor: pointer !important;
            }
        </style>
        <div class="horizontal">
            <oda-icon :icon="allowExpand?(expanded?'icons:chevron-right:90':'icons:chevron-right'):'?'" @tap="expanded = !expanded"></oda-icon>
            <label>{{root?.$item?.label}}</label>
            <div class="flex" ~is="input"></div>
        </div>
        <div ~style="{paddingLeft: iconSize/2, marginLeft: iconSize/2}" class="complex vertical" ~if="expanded">
            <div ~is="complex" :root></div>
        </div>
    `,
    props: {
        iconSize: {
            shared: true
        },
        expanded: false,
        allowExpand: false,
        root: {
            async set(n) {
                if (n) {
                    const items = await n?.items;
                    this.allowExpand = items?.length;
                    this.input = await n.input || 'span';
                    this.complex = await n.complex || 'odant-layout-structure';
                }
            }
        },
        complex: 'odant-layout-structure',
        input: 'span'
    }
})
ODA({
    is: 'odant-layout-structure',
    template: /*html*/`
        <style>
            :host{
                @apply --vertical;
            }
        </style>
        <odant-layout-container ~for="root?.items" :root="item"></odant-layout-container>
    `,
    props: {
        root: Object,
        iconSize: {
            shared: true
        }
    }
})