ODANT({
    imports: [
        '@lib/item-tree',
        '@oda/search-input'
    ],
    is: 'odant-structure-tree',
    extends: 'this, odant-item-tree',
    template: /*html*/`
    <style>
        odant-item-node.root-item{
            background-color: white;
            padding: 4px 8px;
            margin:0;
        }
    </style>
        <oda-search-input ~if="allowSearch" @search="_search" @search-changed="_searchChanged"></oda-search-input>
        <odant-item-node ~if="!hideItemNode" :context-item class="root-item" @tap="focusedItem = contextItem" :selected="focusedItem === contextItem" :focused="focusedItem === contextItem"></odant-item-node>
    `,
    props: {
        itemsList: '_$$structure',
        hideRoot: true,
        hideItemNode: false,
        expandKeysMap: { name: 'Work' },
        // preventExpanding: true,
        lazy: true,
        defaultTemplate: 'odant-structure-node',
        expandItem: Object,
        // focusedItem: {
        //     type: Object,
        //     get() {
        //         return this.focusedNode?.$item;
        //     }
        // },
        allowSearch: true,
        allowInherit: false,
        allowSelection: true,
        allowDrop: 'extended',
        dragOperation: [
            { icon: 'icons:reply', label: 'Move', },
            { icon: 'icons:content-copy', label: 'Copy', },
            { icon: 'icons:link', label: 'Link', },
            { label: 'Inherit', }
        ],
        // focusedNode: {
        //     type: Object,
        //     async watch(node) {
        //         if (node) {
        //             this._expandItemChanged(node.$item, node);
        //         }
        //     }
        // },
        // _readyToDataset: Boolean
    },
    observers: [
        '_expandItemChanged(expandItem)',
    ],
    // detached() {
    //     this.unlisten('event', '_onEvent', { target: this.contextItem });
    // },
    async _getInheritItems(item) {
        const xq = `declare function local:func($base as node(), $id as xs:string){
                        element B{
                        $base /@*,
                        $base/(C,C//C)[@i=$id],
                        for $b in $base/B
                        return local:func($b, $id)
                    }
                };
                local:func(B, '${item.id}')`;
        return CORE.API.post(item.$base.url + '/*', {
            method: 'xquery',
            prefix: 'true'
        }, xq);
    },
    async _expandPath(paths) {
        if (paths.length) {
            const p = paths.pop();
            let node = this.find(i => i.$item?.path === p.path);
            if (node) {
                if (paths.length === 0) {
                    this.focusedNode = node;
                } else {
                    node.items = await this._beforeExpand(node);
                    node.$expanded = true;
                    await this._expandPath(paths);
                }
            }
        }
    },
    // async _onEvent(e, d) {
    //     if (true) {
    //         const node = this.find(i => {
    //             return i.$item === e.currentTarget;
    //         });
    //         if (node && !(d instanceof odaObject)) {
    //             switch (e.source) {
    //                 case 'update':
    //                     node.items = await this._beforeExpand(node) || [];
    //                     break;
    //                 case 'create':
    //                     node.items = await this._beforeExpand(node) || [];
    //                     node.$expanded = true;
    //                     d = node.items.find(i => i.$item.path === d.path);
    //                     this.async(() => {
    //                         this.focusedNode = d;
    //                     }, 100);
    //                     break;
    //                 case 'deleted':
    //                     if (d) {
    //                         this.deleteItems(i => i.$item?.path === d.path, true);
    //                     } else {
    //                         this.deleteItems(i => i.$item?.path === e.currentTarget.path, true);
    //                     }
    //                     break;
    //             }
    //             this._refresh();
    //         }
    //     }
    // },
    async _search(e) {
        const value = e.detail.value;
        if (value) {
            const regExp = /^\/?(?:(?:[HPBSWDMCO]:[0-9A-F]{15}|[P]:(?:WORK)|(?:ROOT)|(?:USER))\/?)*$/;
            if (regExp.test(value)) {
                this.expandItem = await CORE.findItem(value);
            } else {
                // const item = this.contextItem.$host;
                const item = this.contextItem;
                const view = await this.contextItem.findAction('search');
                this.focusedNode = { $item: item, view, tag: 'odant-search', param: value };
            }
        }

    },
    async _searchChanged(e) {
        const value = e.detail.value;
        console.log('_searchChanged: ' + value);
    }
});

ODANT({
    imports: '@lib/item-node',
    is: 'odant-structure-node',
    extends: 'odant-item-node',
    template: /*html*/`<style> :host { overflow: visible !important;} </style>`,
    props: {
        showAccess: true,
        showInherit: true,
    }
});