ODANT({
    imports: '/web/core/user/lib/user-button/user-panel.js',
    is: 'user-button',
    extends: 'odant-item-icon',
    template: /*html*/`
    <style>
        :host {
            @apply --vertical;
            @apply --raised;
            background-color: white;
            border: 2px solid white;
            box-sizing: border-box;
            border-radius: 50%;
            padding: 2px;
            cursor: pointer;
            margin: 2px !important;
        }
    </style>`,
    props: {
        isButton: true,
        contextItem: null,
        opened: false,
        title: {
            type: String,
            reflectToAttribute: true,
            get() {
                return this.contextItem?.label || 'Guest';
            }
        }
    },
    attached() {
        this.contextItem = CORE.host.$user;
        this.style.setProperty('background-color', this.contextItem?.isNotGuest ? 'var(--success-color)' : 'var(--disable-color)');
    },
    listeners: {
        async tap(e) {
            if (this.contextItem?.isNotGuest && !this.opened) {
                this.opened = true;
                await ODA.showDropdown('odant-user-panel', { contextItem: this.contextItem });
                this.opened = false;
            }
            else
                location.assign(`/web/auth/login.html?redirect_url=${location}`);
        }
    },
});