//todo: предусмотреть обработку при других способах авторизации
ODANT({
    is: 'user-panel',
    imports: [
        '@lib/item-icon',
    ],
    template: /*html*/`
    <style>
        :host {
            @apply --vertical;
            @apply --content;
            width: 230px;
            border-radius: 30px;
        }
        odant-item-icon{
            @apply --shadow;
            justify-self: center;
            align-self: center;
            background-color: var(--success-color);
            border-radius: 3px;
            margin-bottom: 16px;
            cursor: pointer;
        }
        oda-button{
            @apply --raised;
            margin: 4px 0;
            padding: 4px 0 !important;
            align-self: normal;
        }
        .body{
            @apply --vertical;
            margin: 16px;
            align-items: center;
        }
        .exit{
            @apply --dark;
        }
    </style>
    <div class="flex horizontal" style="justify-content: flex-end; padding: 4px">
        <oda-icon icon="icons:close" @tap="close"></oda-icon>
    </div>
    <div class="body">
        <odant-item-icon @tap="_profile" icon-size="128" :context-item="contextItem" class="success" default="icons:account-circle"></odant-item-icon>
        <div class="bold" :text="contextItem && contextItem.label"></div>
        <div class="font-70" :text="contextItem && contextItem.login"></div>
        <hr style="width: 100%;margin: 16px 0;">
        <oda-button v-if="contextItem" @tap="_changePass" icon="av:repeat" label="change password"></oda-button>
        <oda-button icon="icons:power-settings-new" @tap="_logout" label="log out" class="exit" fill="firebrick"></oda-button>
    </div>`,
    props: {
        contextItem: Object,
        box: {
            type: Boolean,
            reflectToAttribute: true,
            value: false
        }
    },
    _logout() {
        this.contextItem.logout();
    },
    _profile() {
        this.contextItem.open();
    },
    _changePass(){
        this.contextItem.changePass();
    }
});