import './src/ace.js'
import './webpack-resolver.js'

customElements.define('ace-custom-elements', class extends HTMLElement {
    constructor() {
        super();
        let shadow = this.attachShadow({ mode: "closed" })
            , dom = require("ace/lib/dom")
            , path = ODA.rootPath + '/components/editors/ace-editor/src/';
        ['basePath', 'modePath', 'themePath', 'workerPath'].map(o => ace.config.set(o, path));
        dom.buildDom(
            ["div", { id: "host" },
                ["div", { id: "editor" }],
                ["style", /*css*/`
                    #host {
                        position: relative;
                        height: 100%;
                    }
                    #editor {
                        border-radius: 2px;
                        width: inherit !important;
                        min-height: 100%;
                    }
                    .ace_content{
                        min-height: 100%;
                    }
                `]
            ], shadow);
        const editor = this.aceEditor = ace.edit(shadow.querySelector("#editor"));
        const host = shadow.getElementById('host');
        editor.renderer.attachToShadowRoot();
        let lastTheme = '';
        editor.renderer.addEventListener('themeChange', (n)=>{
            if (lastTheme) host.classList.remove(lastTheme);
            lastTheme = `ace-${n.theme.replace('ace/theme/', '').replace(/_/g, '-')}`;
            host.classList.add(lastTheme);
        })
    }
});
