ODA({
    is: 'oda-basic-input',
    template: /*html*/`
    <style>
      :host{
        @apply --horizontal;
        @apply --flex;
        box-sizing: border-box;
        font-size: 115%;
        background-color: transparent;
        text-align: start;
        border-radius: 1px;
      }
      input {
            border: none;
            background-color: inherit;
            color: inherit;
            overflow: hidden;
            text-overflow: ellipsis;
            width: 100%;
            padding: 4px;
            font-size: inherit;
            text-align: inherit;
        }
        input[type="number"]{
          text-align: end;
        }
        :host([read-only])>input:focus {
            outline: none;
        }
        :host([read-only]) {
            pointer-events: none;
        }
        ::-webkit-input-placeholder {
            opacity: 0.5;
            text-align: start;
        }
        ::-moz-placeholder {
            opacity: 0.5;
            text-align: start;
        }
        :-moz-placeholder {
            opacity: 0.5;
            text-align: start;
        }
        :-ms-input-placeholder {
            opacity: 0.5;
            text-align: start;
        }
    </style>
    <input ref="input" :type :placeholder ::value :min :max :maxlength :minlength :step :accept :autocomplete :pattern
    @focus.stop="_focus" @blur.stop="_blur" list="datalist">
    <datalist id="datalist">
      <option ~for="i in list" :value="i">{{i}}</option>
    </datalist>
    `,
    props: {
        value: '',
        type: 'text',
        placeholder: '',
        min: '',
        max: '',
        maxlength: '',
        minlength: '',
        step: '',
        accept: '',
        autocomplete: '',
        pattern: '',
        list: [],
        focused: false
    },
    listeners: {
        focus() {
            if (this.focused) return;
            this.focused = true;
            this.focus();
        },
    },
    _focus(e){
        if (this.focused) return;
        this.focused = true;
        this.fire('focus', {sourceEvent: e});
    },
    _blur(e){
        if (!this.focused) return;
        this.focused = false;
        this.fire('blur', { sourceEvent: e });
    },
    focus(){
        this.$refs.input.focus();
    },
    blur(){
        this.$refs.input.blur();
    }
});