import '../../../oda.js';
import 'https://cdn.jsdelivr.net/npm/chart.js@2.9.4/dist/Chart.min.js';

ODA({
    is: 'oda-chart',
    template: `
        <style>
            :host {
                position: relative;
                height: 90vh;
            }
        </style>
        <canvas ref="canvas" hidden>     
    `,
    props: {
        type: {
            default: 'line',
            list: ['line', 'bar', 'pie', 'radar', 'doughnut', 'polarArea'],
            set(n) {
                this.updateChart();
            }
        },
        data: {
            type: Object,
            set(n) {
                this.updateChart();
            }
        },
        options: {
            type: Object,
            set(n) {
                this.updateChart();
            }
        },
    },
    listeners: {
        resize: function () {
            this.updateChart();
        }
    },
    ready() {
        this.createChart();
    },
    createChart() {
        this.canvas = this.$refs.canvas;
        this.ctx = this.canvas.getContext('2d');
        this.chart = new Chart(this.ctx, { type: this.type, data: this.data, options: this.options });
        this.isCreateChart = true;
    },
    updateChart() {
        if (!this.isCreateChart) return;
        this.chart.destroy();
        // region FIXME Bug code - with each update, the number of <canvases>++ (only in new oda.js) ???
        var children = this.canvas.parentNode.children;
        for (var i = 0; i < children.length; i++)
            if (children[i].nodeName === 'CANVAS')
                if (children[i] !== this.canvas)
                    this.canvas.parentNode.removeChild(children[i]);
        // endregion
        this.createChart();
    }
})