Команда **ODA.loadJSON** позволяет загрузить ресурс с указанного URL-адреса в формате JSON.

Она вызывается следующим образом:

```javascript
ODA.loadJSON(url);
```

Ей передается один параметр **url** — URL-адрес загружаемого ресурса.

В результате выполнения этой команды возвращается промис с полученным результатом запроса по указанному адресу в формате **JSON**.

Например,

```javascript run_line_edit_loadoda_[my-component.js]_h=100_
import '/components/buttons/icon/icon.js';
ODA({
    is: 'my-component',
    template: `
        <label>URL-адрес: <input type="url" ::value></input></label><br>
        <textarea ::value="text" style="height: 100px; width: 300px" placeholder="Результат запроса"></textarea><br>
        <button @tap="onTap">Загрузить</button>
    `,
    props: {
        value: 'https://odajs.org/tools/languages/dictionaries/ru.json',
        text: ''
    },
    async onTap() {
        let result = await ODA.loadJSON(this.value);
        this.text = JSON.stringify(result);
    }
});
```
