Команда **ODA.loadURL** позволяет загрузить любой ресурс c указанного URL-адреса.

Она вызывается следующим образом:

```javascript
ODA.loadURL(url);
```

Ей передается один параметр **url** — адрес загружаемого ресурса.

В результате выполнения этой команды возвращается промис с полученным результатом запроса по указанному адресу.

Например,

```javascript run_line_edit_loadoda_[my-component.js]_h=100_
import '/components/buttons/icon/icon.js';
ODA({
    is: 'my-component',
    template: `
        <label>URL-адрес: <input type="url" ::value></input></label><br>
        <textarea ::value="text" style="height: 100px; width: 300px" placeholder="Результат запроса"></textarea><br>
        <button @tap="onTap">Загрузить</button>
    `,
    props: {
        value: 'https://odajs.org/oda.js',
        text: ''
    },
    async onTap() {
        let response = await ODA.loadURL(this.value);
        this.text = await response.text();
    }
});
```
