**ODA.language** — это свойство, которое возвращает предпочитаемый пользователем язык.

Как правило это значение зависит от выбранного языка отображения элементов интерфейса браузера.

Это значение возвращается свойством **navigator.language** глобального объекта **window** в виде языкового тега в соответствии со стандартом [RFC 5646](https://tools.ietf.org/html/rfc5646). Например, "en", "EN-US", "RU", "ru-RU" и т.д.

Из этой строки свойство **ODA.language** извлекает только первые символы, идущие до знака дефиса, соответствующие предпочитаемому пользователю языку без учета страны, в которой этот язык используется.

Например,

```javascript run_line_edit_loadoda_[my-component.js]
import '/components/buttons/button/button.js';
 ODA({
    is: 'my-component',
    template: `
        <oda-button ref="btn" :label @tap="onTap"></oda-button>
    `,
    props: {
        label: "Узнай мой предпочитаемый язык общения"
    },
    onTap() {
        this.label = ODA.language;
    }
});
```
