Объектно-ориентированная база данных, которая используется платформой ODANT, относится к «NoSQL» базам данных. С целью обращения к данным используется специальный язык запросов **XQuery**. 

```info
XQuery — это язык запросов и функциональный язык программирования, разработанный для обработки данных в формате XML, простого текста, JSON или других форматах. XQuery практически на 80% совпадает со спецификацией XPath, которая является основой и других технологий (XLST, XQuery, XLink, XPoint).
```

```info
В отличие от XPath, XQuery позволяет не только получать данные из существующих XML-документов, но и формировать свое собственное XML-представление этих данных. 
```

Классическая модель работы языка запросов XQuery имеет следующий вид:

![Классическая модель работы языка запросов XQuery](learn/introduction/images/xquery-working-model.JPG "Классическая модель работы языка запросов XQuery")

На вход XQuery-процессора поступают исходные данные в виде XML-документов или файлов в другом формате и XQuery-запрос на обработку этих данных. XQuery-процессор на основе этого запроса обрабатывает полученные данные и возвращает результат обработки в формате XML или в любом другом формате.

Для формирования своего собственного XML-представления XQuery использует специальные лексические конструкции, которые получили названия **FLWOR**.

```info
FLWOR — это аббревиатура от лексических конструкций языка XQuery: for, let, where, order by и return, которые составляют его основу.
```

В более поздних версиях XQuery к этим элементам была добавлена еще одна конструкции «Group by» и аббревиатура стала называться **FLWGOR**.
Эти аббревиатуры схожи по написанию и по произношению с английским словом «FLOWER», которое переводится как «цветок». Поэтому, лексические конструкции языка XQuery часто представляют в виде изображения цветка.

![FLWGOR](learn/introduction/images/flwgor.JPG "FLWGOR")
